/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2002-2006  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _Decode_h_
#define _Decode_h_

#include <gmime/gmime.h>
#include <pan/general/quark.h>
#include <pan/general/progress.h>

namespace pan
{
  /**
   * Utility for saving a GMimeMessage's binary attachments to disk.
   *
   * @ingroup usenet_utils
   */
  struct Decode
  {
    static bool decode (const Quark                   & path,
                        const Quark                   & filename,
                        GMimeMessage                  * message,
                        Progress                      & progress);
  };
}

#endif // _Decode_h_
